/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package trismegistoplanilla.mysqldao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.json.JSONArray;
import org.json.JSONObject;
import trismegistoplanilla.dao.ContratoDAO;

/**
 *
 * @author sistem20user
 */
public class ContratoMysqlDAO implements ContratoDAO {

	@Override
	public JSONObject listarContrato(JSONObject json) {
		JSONObject jResponse = new JSONObject();
		JSONArray jArray = new JSONArray();
		Connection cn = null;
		PreparedStatement pst = null;
		ResultSet rs = null;

		try {

			cn = MysqlDAOFactory.obtenerConexion("nuevo");

			String busqueda = "";
			if (!json.isNull("numeroDocumento")) {
				busqueda += "and pe.dni = ? ";
			}
			if (!json.isNull("apellido")) {
				busqueda += "and pe.apellidos like concat(?,'%') ";
			}
			if (!json.isNull("estado")) {
				busqueda += "and ec.codigo_tipo_estado_contrato = ? ";
			}
			if (!json.isNull("tipo")) {
				busqueda += "and tc.tipo_contrato_codigo = ? ";
			}
			if (!json.isNull("razonSocial")) {
				busqueda += "and rs.codigo_razon_social = ? ";
			}
			if (!json.isNull("tipoTrabajador")) {
				busqueda += "and co.tipo_trabajador = ? ";
			}

			String sql = ""
				+ "select "
				+ "co.contrato_codigo, "
				+ "pe.codper, "
				+ "CONCAT(co.apellidos,', ',co.nombres) nombrePersonal, "
				+ "co.documento_identidad, "
				+ "co.tipo_documento_identidad, "
				+ "co.area_laboral, "
				+ "co.cargo_laboral, "
				+ "DATE_FORMAT(co.fecha_inicio_contrato,'%d/%m/%Y') fechaInicio, "
				+ "DATE_FORMAT(co.fecha_fin_contrato,'%d/%m/%Y') fechaFin, "
				+ "ec.descripcion estadoContrato, "
				+ "rs.nombre razonSocial,"
				+ "tc.descripcion tipoContrato, "
				+ "ec.codigo_tipo_estado_contrato, "
				+ "tc.tipo_contrato_codigo, "
				+ "rs.codigo_razon_social, "
				+ "pe.direccion, "
				+ "co.monto_asignacion_familiar, "
				+ "co.ingreso_bruto_mensual, "
				+ "co.monto_sueldo_basico, "
				+ "co.monto_asignacion_familiar, "
				+ "co.monto_transporte, "
				+ "co.monto_refrigerio "
				+ "from contrato co "
				+ "inner join personal pe on pe.codper = co.codigo_personal "
				+ "inner join tipo_estado_contrato ec on ec.codigo_tipo_estado_contrato = co.codigo_tipo_estado_contrato "
				+ "left join razon_social rs on rs.codigo_razon_social = co.codigo_razon_social "
				+ "left join tipo_contrato tc on tc.tipo_contrato_codigo = co.codigo_tipo_contrato "
				+ "where co.codigo_tipo_estado_contrato != 4 "
				+ busqueda
				+ "order by nombrePersonal ";

			pst = cn.prepareStatement(sql);

			int q = 1;
			if (!json.isNull("numeroDocumento")) {
				pst.setString(q++, json.getString("numeroDocumento"));
			}
			if (!json.isNull("apellido")) {
				pst.setString(q++, json.getString("apellido"));
			}
			if (!json.isNull("estado")) {
				pst.setString(q++, json.getString("estado"));
			}
			if (!json.isNull("tipo")) {
				pst.setString(q++, json.getString("tipo"));
			}
			if (!json.isNull("razonSocial")) {
				pst.setString(q++, json.getString("razonSocial"));
			}
			if (!json.isNull("tipoTrabajador")) {
				pst.setString(q++, json.getString("tipoTrabajador"));
			}

			rs = pst.executeQuery();

			JSONArray data = new JSONArray();

			while (rs.next()) {
				JSONObject jObj = new JSONObject();
				jObj
					.put("codigoContrato", rs.getString("contrato_codigo"))
					.put("codigoPersonal", rs.getString("codper"))
					.put("nombrePersonal", rs.getString("nombrePersonal"))
					.put("documentoIdentidad", rs.getString("documento_identidad"))
					.put("tipoDocumentoIdentidad", rs.getString("tipo_documento_identidad"))
					.put("areaLaboral", rs.getString("area_laboral"))
					.put("cargoLaboral", rs.getString("cargo_laboral"))
					.put("fechaInicio", rs.getString("fechaInicio"))
					.put("fechaFin", rs.getString("fechaFin"))
					.put("estadoContrato", rs.getString("estadoContrato"))
					.put("razonSocial", rs.getString("razonSocial"))
					.put("codigoEstadoContrato", rs.getString("codigo_tipo_estado_contrato"))
					.put("codigoTipoContrato", rs.getString("tipo_contrato_codigo"))
					.put("codigoRazonSocial", rs.getString("codigo_razon_social"))
					.put("direccion", rs.getString("direccion"))
					.put("asignacionFamiliar", rs.getString("monto_asignacion_familiar"))
					.put("brutoMensual", rs.getString("ingreso_bruto_mensual"))
					.put("sueldoBasico", rs.getString("monto_sueldo_basico"))
					.put("montoTransporte", rs.getString("monto_transporte"))
					.put("montoRefrigerio", rs.getString("monto_refrigerio"))
					.put("tipoContrato", rs.getString("tipoContrato"));

				data.put(jObj);
			}

			jResponse.put("data", data);
			jResponse.put("length", json.getString("length"));
			jResponse.put("draw", json.getString("draw"));

		} catch (Exception e) {
			jResponse.put("status", false);
			jResponse.put("message", "Error : " + e.getMessage());
		}
		return jResponse;
	}

	public static void main(String[] args) {
		System.out.println("" + new ContratoMysqlDAO().listarContrato(new JSONObject()));
	}

	@Override
	public JSONObject obtenerDataRazonSocialContrato(int razonSocial) {
		JSONObject jResponse = new JSONObject();
		Connection cn = null;
		PreparedStatement pst = null;
		ResultSet rs = null;

		try {

			cn = MysqlDAOFactory.obtenerConexion("nuevo");

			String sql = ""
				+ "select "
				+ "rs.nombre razonSocial, "
				+ "rs.ruc, "
				+ "drs.domicilio_real, "
				+ "drs.nombre_representante, "
				+ "drs.dni, "
				+ "drs.numero_partida_inscrita, "
				+ "drs.distrito "
				+ "from data_razon_social drs "
				+ "inner join razon_social rs on rs.codigo_razon_social = drs.codigo_razon_social "
				+ "where rs.codigo_razon_social = ? ";

			pst = cn.prepareStatement(sql);

			pst.setInt(1, razonSocial);

			rs = pst.executeQuery();

			JSONObject jObj = null;

			if (rs.next()) {
				jObj = new JSONObject();
				jObj
					.put("razonSocial", rs.getString("razonSocial"))
					.put("ruc", rs.getString("ruc"))
					.put("domicilioReal", rs.getString("domicilio_real"))
					.put("nombreRepresentante", rs.getString("nombre_representante"))
					.put("dni", rs.getString("dni"))
					.put("numeroPartidaInscrita", rs.getString("numero_partida_inscrita"))
					.put("distrito", rs.getString("distrito"));
			}

			if (jObj != null) {
				jResponse.put("status", true);
				jResponse.put("data", jObj);
			} else {
				jResponse.put("status", false);
			}

		} catch (Exception e) {
			jResponse.put("status", false);
			jResponse.put("message", "Error : " + e.getMessage());
		}
		return jResponse;
	}

	@Override
	public JSONObject actualizarContratoGeneradoAdministrativo(JSONArray jArray) {
		JSONObject jResponse = new JSONObject();
		Connection cn = null;
		PreparedStatement pst = null;

		try {
			cn = MysqlDAOFactory.obtenerConexion("nuevo");
			cn.setAutoCommit(false);
			String sql = "update contrato set "
				+ "monto_sueldo_basico = ?, "
				+ "monto_asignacion_familiar = ?, "
				+ "monto_transporte = ?, "
				+ "monto_refrigerio = ?, "
				+ "fecha_inicio_contrato = STR_TO_DATE(?,'%d/%m/%Y'), "
				+ "fecha_fin_contrato = STR_TO_DATE(?,'%d/%m/%Y'), "
				+ "codigo_tipo_estado_contrato = 2, "
				+ "codigo_tipo_contrato = ?, "
				+ "codigo_razon_social = ? "
				+ "where contrato_codigo = ? ";

			pst = cn.prepareStatement(sql);

			for (Object obj : jArray) {
				JSONObject jContrato = (JSONObject) obj;
				int rs = 0;

				int q = 1;
				pst.setString(q++, jContrato.getString("basico"));
				pst.setString(q++, jContrato.getString("asignacionFamiliar"));
				pst.setString(q++, jContrato.getString("transporte"));
				pst.setString(q++, jContrato.getString("refrigerio"));
				pst.setString(q++, jContrato.getString("fechaInicio"));
				pst.setString(q++, jContrato.getString("fechaFin"));
				pst.setString(q++, jContrato.getString("codigoTipoContrato"));
				pst.setString(q++, jContrato.getString("codigoRazonSocial"));
				pst.setString(q++, jContrato.getString("codigoContrato"));

				rs = pst.executeUpdate();

				if (rs == 0) {
					throw new Exception("Error al actualizar contrato.");
				}
			}

			cn.commit();
			jResponse
				.put("status", true)
				.put("message", "Se generaron los contratos exitosamente.");

		} catch (Exception e) {
			try {
				cn.rollback();
				jResponse
					.put("status", false)
					.put("message", "Error: " + e.getMessage());
			} catch (SQLException ex) {
				Logger.getLogger(ContratoMysqlDAO.class.getName()).log(Level.SEVERE, null, ex);
			}
		} finally {
			try {
				if (cn != null) {
					cn.close();
				}
				if (pst != null) {
					cn.close();
				}
			} catch (SQLException ex) {
				Logger.getLogger(ContratoMysqlDAO.class.getName()).log(Level.SEVERE, null, ex);
			}
		}
		return jResponse;
	}

}
