/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package trismegistoplanilla.servlets;

import com.itextpdf.text.DocumentException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.json.JSONArray;
import org.json.JSONObject;
import trismegistoplanilla.servicesMysql.ContratoService;
import trismegistoplanilla.utilities.PdfCreator;

/**
 *
 * @author sistem20user
 */
public class ContratoServlet extends HttpServlet {
	
	@Override
	protected void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String accion = request.getParameter("accion");
		switch (accion) {
			case "listarContrato":
				listarContrato(request, response);
				break;
			case "actualizarContratoGeneradoAdministrativo":
				actualizarContratoGeneradoAdministrativo(request, response);
				break;
			case "contratoPdf": {
				try {
					contratoPdf(request, response);
				} catch (DocumentException ex) {
					Logger.getLogger(ContratoServlet.class.getName()).log(Level.SEVERE, null, ex);
				}
				break;
			}
			default:
		}
	}
	
	private void listarContrato(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter pw = response.getWriter();
		String filter = request.getParameter("json");
		String start = request.getParameter("start");
		String length = request.getParameter("length");
		String draw = request.getParameter("draw");
		JSONObject jRequest = new JSONObject(filter)
			.put(start, start)
			.put(length, length)
			.put(draw, draw);
		ContratoService service = new ContratoService();
		JSONObject jResponse = service.listarContrato(jRequest);
		
		pw.print(jResponse);
	}
	
	private void contratoPdf(HttpServletRequest request, HttpServletResponse response) throws IOException, DocumentException {
		
		String fileName = "loteAdministrativo.pdf";
		response.setContentType("application/pdf");
		response.setHeader("Expires", "0");
		response.setHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0");
		response.setHeader("Content-Disposition", "inline; filename=" + fileName);
		response.setHeader("Accept-Ranges", "bytes");
		JSONObject json = new JSONObject(request.getParameter("json"));
		new PdfCreator().escogerMetodo(json, response);
	}
	
	private void actualizarContratoGeneradoAdministrativo(HttpServletRequest request, HttpServletResponse response) throws IOException {
		response.setContentType("application/json");
		PrintWriter pw = response.getWriter();
		ContratoService service = new ContratoService();
		JSONArray jRequest = new JSONArray(request.getParameter("jsonArray"));
		JSONObject jResponse = service.actualizarContratoGeneradoAdministrativo(jRequest);
		pw.print(jResponse);
	}
	
}
