/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package trismegistoplanilla.utilities;

import com.itextpdf.text.Anchor;
import com.itextpdf.text.Chunk;
import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.pdf.ColumnText;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfPageEventHelper;
import com.itextpdf.text.pdf.PdfWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URISyntaxException;
import java.net.URL;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;
import javax.servlet.http.HttpServletResponse;
import jdk.nashorn.internal.objects.NativeDebug;
import org.json.JSONObject;
import trismegistoplanilla.servicesMysql.ContratoService;

/**
 *
 * @author sistem20user
 */
public class PdfCreator {

	public void escogerMetodo(JSONObject json, HttpServletResponse response) throws IOException, DocumentException {
		switch (json.getString("codigoTipoContrato")) {
			case "1":
				crearPdfContratoNecesidadMercado(json, response);
				break;
			case "2":
				crearPdfContratoTiempoParcial(json, response);
				break;
			default:
		}
	}

	public boolean crearPdfContratoNecesidadMercado(JSONObject json, HttpServletResponse response) throws IOException, DocumentException {
//	public static boolean crearPdfContratoNecesidadMercado(JSONObject json) throws IOException, DocumentException {
		boolean respuesta = false;
		Document documento = new Document(PageSize.A4.rotate(), 100, 100, 30, 30);
//		PdfWriter writer = PdfWriter.getInstance(documento, response.getOutputStream());
		PdfWriter.getInstance(documento, response.getOutputStream());
//		MyFooter event = new MyFooter();
//		writer.setPageEvent(event);
		documento.open();

		int codigoRazonSocial = Integer.parseInt(json.getString("codigoRazonSocial"));
		ContratoService service = new ContratoService();
		JSONObject jResponse = service.obtenerDataRazonSocialContrato(codigoRazonSocial);

		if (jResponse.getBoolean("status")) {
			JSONObject jDataRS = jResponse.getJSONObject("data");
			String razonSocial = jDataRS.getString("razonSocial");
			String ruc = jDataRS.getString("ruc");
			String domicilioReal = jDataRS.getString("domicilioReal");
			String nombreRepresentante = jDataRS.getString("nombreRepresentante");
			String dni = jDataRS.getString("dni");
			String numeroPartidaInscrita = jDataRS.getString("numeroPartidaInscrita");
			String distrito = jDataRS.getString("distrito");

			List<String> template = getTemplateContrato(1);
			String lineas = "";

			for (String linea : template) {
				lineas += linea;
			}

			lineas = lineas
				.replace("@br", "\n")
				.replace("@razonSocial", razonSocial)
				.replace("@domicilioReal", domicilioReal)
				.replace("@nombreResponsable", nombreRepresentante)
				.replace("@dniResponsable", dni)
				.replace("@numeroPartida", numeroPartidaInscrita)
				.replace("@distritoFirma", distrito)
				.replace("@nombrePersonal", json.getString("nombrePersonal"))
				.replace("@tipoDocumento", json.getString("tipoDocumentoIdentidad"))
				.replace("@numeroDocumento", json.getString("documentoIdentidad"))
				.replace("@domicilioPersonal", json.getString("direccion"))
				.replace("@sueldoMensual", json.getString("brutoMensual"))
				.replace("@basicoMensual", json.getString("sueldoBasico"))
				.replace("@asignacionFamiliar", json.getString("asignacionFamiliar"))
				.replace("@asignacionTransporte", json.getString("montoTransporte"))
				.replace("@ruc", ruc);

			Phrase phrase = new Phrase();
			Paragraph paragraph = new Paragraph();
			Font underlineFont = new Font(Font.FontFamily.HELVETICA, 15, Font.UNDERLINE);
			Font paragraphFont = new Font(Font.FontFamily.TIMES_ROMAN, 8, Font.NORMAL);
			Chunk underlineChunk = new Chunk("CONTRATO DE TRABAJO POR NECESIDADES DEL MERCADO", underlineFont);
			phrase.add(underlineChunk);

			paragraph.add(phrase);
			paragraph.setAlignment(Element.ALIGN_CENTER);
			documento.add(paragraph);
			documento.add(Chunk.NEWLINE);
			documento.add(Chunk.NEWLINE);
			documento.add(new Paragraph(lineas, paragraphFont));

			documento.close();
		}

		return respuesta;
	}

//	public static boolean crearPdfContratoTiempoParcial(JSONObject json) throws IOException, DocumentException {
	public static boolean crearPdfContratoTiempoParcial(JSONObject json, HttpServletResponse response) throws IOException, DocumentException {
		boolean respuesta = false;

		Document documento = new Document(PageSize.A4.rotate(), 100, 100, 30, 30);
//		PdfWriter writer = PdfWriter.getInstance(documento, response.getOutputStream());
//		PdfWriter.getInstance(documento, new FileOutputStream("D:\\contratoPDF.pdf"));
		PdfWriter.getInstance(documento, response.getOutputStream());
//		MyFooter event = new MyFooter();
//		writer.setPageEvent(event);
		documento.open();

		int codigoRazonSocial = Integer.parseInt(json.getString("codigoRazonSocial"));
		ContratoService service = new ContratoService();
		JSONObject jResponse = service.obtenerDataRazonSocialContrato(codigoRazonSocial);

		if (jResponse.getBoolean("status")) {
			JSONObject jDataRS = jResponse.getJSONObject("data");
			String razonSocial = jDataRS.getString("razonSocial");
			String ruc = jDataRS.getString("ruc");
			String domicilioReal = jDataRS.getString("domicilioReal");
			String nombreRepresentante = jDataRS.getString("nombreRepresentante");
			String dni = jDataRS.getString("dni");
			String numeroPartidaInscrita = jDataRS.getString("numeroPartidaInscrita");
			String distrito = jDataRS.getString("distrito");

			List<String> template = getTemplateContrato(2);
			String lineas = "";

			lineas = template.stream().map((linea) -> linea).reduce(lineas, String::concat);

			lineas = lineas
				.replace("@br", "\n")
				.replace("@razonSocial", razonSocial)
				.replace("@domicilioReal", domicilioReal)
				.replace("@nombreResponsable", nombreRepresentante)
				.replace("@dniResponsable", dni)
				.replace("@numeroPartida", numeroPartidaInscrita)
				.replace("@distritoFirma", distrito)
				.replace("@nombrePersonal", json.getString("nombrePersonal"))
				.replace("@tipoDocumento", json.getString("tipoDocumentoIdentidad"))
				.replace("@numeroDocumento", json.getString("documentoIdentidad"))
				.replace("@domicilioResponsable", json.getString("direccion"))
				.replace("@sueldoMensual", json.getString("brutoMensual"))
				.replace("@basicoMensual", json.getString("sueldoBasico"))
				.replace("@asignacionFamiliar", json.getString("asignacionFamiliar"))
				.replace("@asignacionTransporte", json.getString("montoTransporte"))
				.replace("@asignacionRefrigerio", json.getString("montoRefrigerio"))
				.replace("@ruc", ruc);

			Phrase phrase = new Phrase();
			Paragraph paragraph = new Paragraph();
			Font underlineFont = new Font(Font.FontFamily.HELVETICA, 15, Font.UNDERLINE);
			Font paragraphFont = new Font(Font.FontFamily.TIMES_ROMAN, 8, Font.NORMAL);

			Chunk underlineChunk = new Chunk("CONTRATO DE TRABAJO EN REGIMEN DE TIEMPO PARCIAL", underlineFont);
			phrase.add(underlineChunk);

			paragraph.add(phrase);
			paragraph.setAlignment(Element.ALIGN_CENTER);
			documento.add(paragraph);
			documento.add(Chunk.NEWLINE);
			documento.add(Chunk.NEWLINE);
			documento.add(new Paragraph(lineas, paragraphFont));

			documento.close();
		}

		return respuesta;
	}

	class MyFooter extends PdfPageEventHelper {

		Font ffont = new Font(Font.FontFamily.COURIER, 5, Font.BOLD);

		@Override
		public void onEndPage(PdfWriter writer, Document document) {
//      String timeStamp = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss").format(Calendar.getInstance().getTime());
			String datetime = DateTimeServer.getDateTimeServer();
			PdfContentByte cb = writer.getDirectContent();
			Phrase footer = new Phrase(datetime, ffont);
			ColumnText.showTextAligned(cb, Element.ALIGN_CENTER,
				footer,
				(document.right() - document.left()) / 2 + document.leftMargin(),
				document.bottom() - 1, 0);
		}
	}

	public static List<String> getTemplateContrato(int codigoTipoContrato) {

		String tipoContrato = "";

		switch (codigoTipoContrato) {
			case 1:
				tipoContrato = "necesidad-de-mercado";
				break;
			case 2:
				tipoContrato = "contrato-tiempo-parcial";
				break;
			case 3:
				tipoContrato = "mensual-por-horas";
				break;
			case 4:
				tipoContrato = "recibo-por-honorarios";
				break;
			case 5:
				tipoContrato = "tiempo-parcial-por-horas";
				break;
			default:
		}

		URL url = new PdfCreator().getClass().getClassLoader().getResource(tipoContrato + ".txt");

		Path path = Paths.get(url.getPath().substring(1));
		final List<String> template = new ArrayList<>();

		try (Stream<String> stream = Files.lines(path)) {
			stream.forEach(s -> {
				template.add(s);
			});

		} catch (IOException e) {
			e.printStackTrace();
		}
		return template;
	}

	public static void main(String[] args) throws IOException, DocumentException, URISyntaxException, URISyntaxException, Exception {
//		JSONObject obj = new JSONObject().put("razonSocial", 2);
//		crearPdfContratoTiempoParcial(obj);
	}

}
